// @generated Code generated by thrift-gen. Do not modify.

// Package driver is generated code used to make or handle TChannel calls using Thrift.
package driver

import (
	"fmt"

	athrift "github.com/apache/thrift/lib/go/thrift"
	"github.com/uber/tchannel-go/thrift"
)

// Interfaces for the service and client for the services defined in the IDL.

// TChanDriver is the interface that defines the server handler and client interface.
type TChanDriver interface {
	FindNearest(ctx thrift.Context, location string) ([]*DriverLocation, error)
}

// Implementation of a client and service handler.

type tchanDriverClient struct {
	thriftService string
	client        thrift.TChanClient
}

func NewTChanDriverInheritedClient(thriftService string, client thrift.TChanClient) *tchanDriverClient {
	return &tchanDriverClient{
		thriftService,
		client,
	}
}

// NewTChanDriverClient creates a client that can be used to make remote calls.
func NewTChanDriverClient(client thrift.TChanClient) TChanDriver {
	return NewTChanDriverInheritedClient("Driver", client)
}

func (c *tchanDriverClient) FindNearest(ctx thrift.Context, location string) ([]*DriverLocation, error) {
	var resp DriverFindNearestResult
	args := DriverFindNearestArgs{
		Location: location,
	}
	success, err := c.client.Call(ctx, c.thriftService, "findNearest", &args, &resp)
	if err == nil && !success {
	}

	return resp.GetSuccess(), err
}

type tchanDriverServer struct {
	handler TChanDriver
}

// NewTChanDriverServer wraps a handler for TChanDriver so it can be
// registered with a thrift.Server.
func NewTChanDriverServer(handler TChanDriver) thrift.TChanServer {
	return &tchanDriverServer{
		handler,
	}
}

func (s *tchanDriverServer) Service() string {
	return "Driver"
}

func (s *tchanDriverServer) Methods() []string {
	return []string{
		"findNearest",
	}
}

func (s *tchanDriverServer) Handle(ctx thrift.Context, methodName string, protocol athrift.TProtocol) (bool, athrift.TStruct, error) {
	switch methodName {
	case "findNearest":
		return s.handleFindNearest(ctx, protocol)

	default:
		return false, nil, fmt.Errorf("method %v not found in service %v", methodName, s.Service())
	}
}

func (s *tchanDriverServer) handleFindNearest(ctx thrift.Context, protocol athrift.TProtocol) (bool, athrift.TStruct, error) {
	var req DriverFindNearestArgs
	var res DriverFindNearestResult

	if err := req.Read(protocol); err != nil {
		return false, nil, err
	}

	r, err :=
		s.handler.FindNearest(ctx, req.Location)

	if err != nil {
		return false, nil, err
	} else {
		res.Success = r
	}

	return err == nil, &res, nil
}
